﻿using Demo.Reuse.WP7.Helpers;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Ioc;
using Microsoft.Practices.ServiceLocation;
using Reuse.PCL.Services;
using Reuse.WP7.Services;
using System;
using System.Collections.Generic;
using System.Windows;

namespace Demo.Reuse.WP7.ViewModel {
	public class VMLocator {
		static VMLocator() {
			// Establecer el Service Locator de MVVM Light
			ServiceLocator.SetLocatorProvider( () => SimpleIoc.Default );

			if ( ViewModelBase.IsInDesignModeStatic ) {
				// Definir servicios de tiempo de diseño aquí
			} else {
				// Registrar Servicios con interfaz y clase que la implementa
				SimpleIoc.Default.Register<INavigationService>( () => new NavigationService( ( (App)Application.Current ).RootFrame ) {
					WPRoutingTable = new Dictionary<string, Uri>(){
					{Constants.Views.VMyView, Constants.Views.VMyViewUrl}
					}
				} );
				
				SimpleIoc.Default.Register<IStateService, StateService>();
				SimpleIoc.Default.Register<INetworkService, NetworkService>();
				// Registrar ViewModels así
				SimpleIoc.Default.Register<VMHub>();
			}

		}

		// Exponer ViewModels así
		public VMHub VMHub {
			get {
				return ServiceLocator.Current.GetInstance<VMHub>();
			}
		}
	}
}
